VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
END
Attribute VB_Name = "CUserinfo"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Private Declare PtrSafe Function GetUserName Lib "advapi32.dll" Alias "GetUserNameA" (ByVal lpBuffer As String, nSize As Long) As Long

Private Type UserinfoType
  UserName      As String
  Company       As String
  Country       As String
  FullName      As String
  zip           As String
  City          As String
  MailAdress    As String
  Department    As String
  Description   As Variant
  streetAddress As String
  GivenName     As String
  SureName      As String
  Title         As String
  OfficePhone   As String
  MobilePhone   As String
  Manager       As String
End Type

Private this    As UserinfoType
 
Public strPath As String

Public Property Get Manager() As String
    Manager = this.Manager
End Property

Public Property Let Manager(ByVal value As String)
    this.Manager = value
End Property
Public Property Get MobilePhone() As String
    MobilePhone = this.MobilePhone
End Property

Public Property Let MobilePhone(ByVal value As String)
    this.MobilePhone = value
End Property

Public Property Get OfficePhone() As String
    OfficePhone = this.OfficePhone
End Property

Public Property Let OfficePhone(ByVal value As String)
    this.OfficePhone = value
End Property

Public Property Get Title() As String
    Title = this.Title
End Property

Public Property Let Title(ByVal value As String)
    this.Title = value
End Property

Public Property Get SureName() As String
    SureName = this.SureName
End Property

Public Property Let SureName(ByVal value As String)
    this.SureName = value
End Property
Public Property Get GivenName() As String
    GivenName = this.GivenName
End Property

Public Property Let GivenName(ByVal value As String)
    this.GivenName = value
End Property
Public Property Get streetAddress() As String
    streetAddress = this.streetAddress
End Property

Public Property Let streetAddress(ByVal value As String)
    this.streetAddress = value
End Property

Public Property Get Description() As Variant
    Description = this.Description
End Property

Public Property Let Description(ByVal value As Variant)
    this.Description = value
End Property
Public Property Get Department() As String
    Department = this.Department
End Property

Public Property Let Department(ByVal value As String)
    this.Department = value
End Property
Public Property Get MailAdress() As String
    MailAdress = this.MailAdress
End Property

Public Property Let MailAdress(ByVal value As String)
    this.MailAdress = value
End Property

Public Property Get UserName() As String
    UserName = this.UserName
End Property

Public Property Let UserName(ByVal value As String)
    this.UserName = value
End Property

Public Property Get Company() As String
    Company = this.Company
End Property

Public Property Let Company(ByVal value As String)
    this.Company = value
End Property
Public Property Get Country() As String
    Country = this.Country
End Property

Public Property Let Country(ByVal value As String)
    this.Country = value
End Property
Public Property Get FullName() As String
    FullName = this.FullName
End Property

Public Property Let FullName(ByVal value As String)
    this.FullName = value
End Property
Public Property Get zip() As String
    zip = this.zip
End Property

Public Property Let zip(ByVal value As String)
    this.zip = value
End Property

Public Property Get City() As String
    City = this.City
End Property

Public Property Let City(ByVal value As String)
    this.City = value
End Property

Public Sub Class_Initialize()
  UserName = ""
  UserInfo = ""
  strPath = "LDAP://" & Environ("USERDNSDOMAIN")
End Sub


' Gibt den Benutzernamen des aktuell angemeldeten Benutzers zurck
Public Function GetNetworkUserName() As String
  Dim Buffer As String * 100
  Dim BuffLen As Long
    
  BuffLen = 100
  GetUserName Buffer, BuffLen
  GetNetworkUserName = Left(Buffer, BuffLen - 1)
End Function


Public Sub GetUserInfo(Optional UserName As String)
  Dim temp As UserinfoType
  
  base = "<" & strPath & ">"
  
  If UserName = "" Then
    fltr = "(sAMAccountName=" & GetNetworkUserName & ")"
  Else
    fltr = "(sAMAccountName=" & UserName & ")"
  End If
    
  attr = "distinguishedName,sAMAccountName,c,postalcode,l,company,DisplayName,mail,department,Description,streetAddress,GivenName,sn,title,telephoneNumber,mobile,manager"
  scope = "subtree"

  Set conn = CreateObject("ADODB.Connection")
  conn.Provider = "ADsDSOObject"
  conn.Open "Active Directory Provider"

  Set cmd = CreateObject("ADODB.Command")
  Set cmd.ActiveConnection = conn
  cmd.CommandText = base & ";" & fltr & ";" & attr & ";" & scope

  Set rs = cmd.Execute
  this.UserName = rs.fields("sAMAccountName")
  If IsNull(rs.fields("c")) Then this.Country = "-" Else this.Country = rs.fields("c")
  If IsNull(rs.fields("company")) Then this.Company = "-" Else this.Company = rs.fields("company")
  If IsNull(rs.fields("DisplayName")) Then this.FullName = "-" Else this.FullName = rs.fields("DisplayName")
  If IsNull(rs.fields("postalcode")) Then this.zip = "-" Else this.zip = rs.fields("postalcode")
  If IsNull(rs.fields("l")) Then this.City = "-" Else this.City = rs.fields("l")
  If IsNull(rs.fields("mail")) Then this.MailAdress = "-" Else this.MailAdress = rs.fields("mail")
  If IsNull(rs.fields("department")) Then this.Department = "-" Else this.Department = rs.fields("department")
  If IsNull(rs.fields("Description")) Then this.Description = "-" Else this.Description = rs.fields("Description")
  If IsNull(rs.fields("streetAddress")) Then this.streetAddress = "-" Else this.streetAddress = rs.fields("streetAddress")
  If IsNull(rs.fields("GivenName")) Then this.GivenName = "-" Else this.GivenName = rs.fields("GivenName")
  If IsNull(rs.fields("sn")) Then this.SureName = "-" Else this.SureName = rs.fields("sn")
  If IsNull(rs.fields("title")) Then this.Title = "-" Else this.Title = rs.fields("title")
  If IsNull(rs.fields("telephoneNumber")) Then this.OfficePhone = "-" Else this.OfficePhone = rs.fields("telephoneNumber")
  If IsNull(rs.fields("mobile")) Then this.MobilePhone = "-" Else this.MobilePhone = rs.fields("mobile")
  If IsNull(rs.fields("manager")) Then this.Manager = "-" Else this.Manager = rs.fields("manager")
  rs.Close

  conn.Close
  
  
End Sub


